Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/UserDefinedAlgorithmView.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/UserDefinedAlgorithmView.cs	(revision 2851)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/UserDefinedAlgorithmView.cs	(revision 2851)
@@ -0,0 +1,116 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Windows.Forms;
+using HeuristicLab.Core;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+using HeuristicLab.Persistence.Default.Xml;
+
+namespace HeuristicLab.Optimization.Views { 
+  /// <summary>
+  /// The base class for visual representations of items.
+  /// </summary>
+  [Content(typeof(UserDefinedAlgorithm), true)]
+  public sealed partial class UserDefinedAlgorithmView : EngineAlgorithmView {
+    public new UserDefinedAlgorithm Content {
+      get { return (UserDefinedAlgorithm)base.Content; }
+      set { base.Content = value; }
+    }
+
+    /// <summary>
+    /// Initializes a new instance of <see cref="ItemBaseView"/>.
+    /// </summary>
+    public UserDefinedAlgorithmView() {
+      InitializeComponent();
+    }
+    /// <summary>
+    /// Intializes a new instance of <see cref="ItemBaseView"/> with the given <paramref name="item"/>.
+    /// </summary>
+    /// <param name="item">The item that should be displayed.</param>
+    public UserDefinedAlgorithmView(UserDefinedAlgorithm content)
+      : this() {
+      Content = content;
+    }
+
+    protected override void DeregisterContentEvents() {
+      Content.OperatorGraphChanged -= new EventHandler(Content_OperatorGraphChanged);
+      base.DeregisterContentEvents();
+    }
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.OperatorGraphChanged += new EventHandler(Content_OperatorGraphChanged);
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        operatorGraphViewHost.Content = null;
+        globalScopeView.Content = null;
+      } else {
+        operatorGraphViewHost.Content = Content.OperatorGraph;
+        globalScopeView.Content = Content.GlobalScope;
+      }
+    }
+
+    private void Content_OperatorGraphChanged(object sender, EventArgs e) {
+      if (InvokeRequired)
+        Invoke(new EventHandler(Content_OperatorGraphChanged), sender, e);
+      else
+        operatorGraphViewHost.Content = Content.OperatorGraph;
+    }
+
+    private void newOperatorGraphButton_Click(object sender, EventArgs e) {
+      Content.OperatorGraph = new OperatorGraph();
+    }
+    private void openOperatorGraphButton_Click(object sender, EventArgs e) {
+      openFileDialog.Title = "Open Operator Graph";
+      if (openFileDialog.ShowDialog(this) == DialogResult.OK) {
+        OperatorGraph operatorGraph = null;
+        try {
+          operatorGraph = XmlParser.Deserialize(openFileDialog.FileName) as OperatorGraph;
+        }
+        catch (Exception ex) {
+          Auxiliary.ShowErrorMessageBox(ex);
+        }
+        if (operatorGraph == null)
+          MessageBox.Show(this, "Selected file does not contain an operator graph.", "Invalid File", MessageBoxButtons.OK, MessageBoxIcon.Error);
+        else
+          Content.OperatorGraph = operatorGraph;
+      }
+    }
+    private void saveOperatorGraphButton_Click(object sender, EventArgs e) {
+      saveFileDialog.Title = "Save Operator Graph";
+      if (saveFileDialog.ShowDialog(this) == DialogResult.OK) {
+        try {
+          if (saveFileDialog.FilterIndex == 1)
+            XmlGenerator.Serialize(Content.OperatorGraph, saveFileDialog.FileName, 0);
+          else
+            XmlGenerator.Serialize(Content.OperatorGraph, saveFileDialog.FileName, 9);
+        }
+        catch (Exception ex) {
+          Auxiliary.ShowErrorMessageBox(ex);
+        }
+      }
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Optimization/3.3/Algorithm.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/Algorithm.cs	(revision 2851)
+++ trunk/sources/HeuristicLab.Optimization/3.3/Algorithm.cs	(revision 2851)
@@ -0,0 +1,142 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Drawing;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Optimization {
+  /// <summary>
+  /// A base class for algorithms.
+  /// </summary>
+  [Item("Algorithm", "A base class for algorithms.")]
+  public abstract class Algorithm : ParameterizedNamedItem, IAlgorithm {
+    public override Image ItemImage {
+      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.Event; }
+    }
+
+    private IProblem problem;
+    [Storable]
+    public IProblem Problem {
+      get { return problem; }
+      set {
+        if (problem != value) {
+          if (problem != null) problem.Changed -= new ChangedEventHandler(Problem_Changed);
+          problem = value;
+          if (problem != null) problem.Changed += new ChangedEventHandler(Problem_Changed);
+          OnProblemChanged();
+        }
+      }
+    }
+
+    public abstract TimeSpan ExecutionTime { get; }
+
+    private bool running;
+    public bool Running {
+      get { return running; }
+    }
+
+    public abstract bool Finished { get; }
+
+    private bool canceled;
+    protected bool Canceled {
+      get { return canceled; }
+      private set {
+        if (canceled != value) {
+          canceled = value;
+          OnCanceledChanged();
+        }
+      }
+    }
+
+    protected Algorithm() : base() { }
+    protected Algorithm(string name) : base(name) { }
+    protected Algorithm(string name, ParameterCollection parameters) : base(name, parameters) { }
+    protected Algorithm(string name, string description) : base(name, description) { }
+    protected Algorithm(string name, string description, ParameterCollection parameters) : base(name, description, parameters) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      Algorithm clone = (Algorithm)base.Clone(cloner);
+      clone.Problem = (IProblem)cloner.Clone(problem);
+      clone.running = running;
+      clone.Canceled = canceled;
+      return clone;
+    }
+
+    public void Prepare() {
+      running = false;
+      Canceled = false;
+      OnPrepared();
+    }
+    public void Start() {
+      running = true;
+      Canceled = false;
+      OnStarted();
+    }
+    public void Stop() {
+      Canceled = true;
+    }
+
+    #region Events
+    public event EventHandler ProblemChanged;
+    protected virtual void OnProblemChanged() {
+      if (ProblemChanged != null)
+        ProblemChanged(this, EventArgs.Empty);
+      OnChanged();
+    }
+    public event EventHandler ExecutionTimeChanged;
+    protected virtual void OnExecutionTimeChanged() {
+      if (ExecutionTimeChanged != null)
+        ExecutionTimeChanged(this, EventArgs.Empty);
+      OnChanged();
+    }
+    public event EventHandler Prepared;
+    protected virtual void OnPrepared() {
+      if (Prepared != null)
+        Prepared(this, EventArgs.Empty);
+      OnChanged();
+    }
+    public event EventHandler Started;
+    protected virtual void OnStarted() {
+      if (Started != null)
+        Started(this, EventArgs.Empty);
+      OnChanged();
+    }
+    public event EventHandler Stopped;
+    protected virtual void OnStopped() {
+      if (Stopped != null)
+        Stopped(this, EventArgs.Empty);
+      OnChanged();
+    }
+    protected virtual void OnCanceledChanged() { }
+    public event EventHandler<EventArgs<Exception>> ExceptionOccurred;
+    protected virtual void OnExceptionOccurred(Exception exception) {
+      if (ExceptionOccurred != null)
+        ExceptionOccurred(this, new EventArgs<Exception>(exception));
+    }
+    private void Problem_Changed(object sender, ChangedEventArgs e) {
+      OnChanged(e);
+    }
+    #endregion
+  }
+}
Index: trunk/sources/HeuristicLab.Optimization/3.3/EngineAlgorithm.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/EngineAlgorithm.cs	(revision 2851)
+++ trunk/sources/HeuristicLab.Optimization/3.3/EngineAlgorithm.cs	(revision 2851)
@@ -0,0 +1,184 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Optimization {
+  /// <summary>
+  /// A base class for algorithms which use an engine for execution.
+  /// </summary>
+  [Item("EngineAlgorithm", "A base class for algorithms which use an engine for execution.")]
+  public abstract class EngineAlgorithm : Algorithm {
+    private OperatorGraph operatorGraph;
+    [Storable]
+    protected OperatorGraph OperatorGraph {
+      get { return operatorGraph; }
+      set {
+        if (value == null) throw new ArgumentNullException();
+        if (value != operatorGraph) {
+          if (operatorGraph != null) operatorGraph.InitialOperatorChanged -= new EventHandler(OperatorGraph_InitialOperatorChanged);
+          operatorGraph = value;
+          if (operatorGraph != null) operatorGraph.InitialOperatorChanged += new EventHandler(OperatorGraph_InitialOperatorChanged);
+          OnOperatorGraphChanged();
+          Prepare();
+        }
+      }
+    }
+
+    [Storable]
+    private IScope globalScope;
+    protected IScope GlobalScope {
+      get { return globalScope; }
+    }
+
+    private IEngine engine;
+    [Storable]
+    public IEngine Engine {
+      get { return engine; }
+      set {
+        if (engine != value) {
+          if (engine != null) DeregisterEngineEvents();
+          engine = value;
+          if (engine != null) RegisterEngineEvents();
+          OnEngineChanged();
+          Prepare();
+        }
+      }
+    }
+
+    public override TimeSpan ExecutionTime {
+      get {
+        if (engine == null) return TimeSpan.Zero;
+        else return engine.ExecutionTime;
+      }
+    }
+
+    public override bool Finished {
+      get {
+        if (engine == null) return true;
+        else return engine.Finished;
+      }
+    }
+
+    protected EngineAlgorithm()
+      : base() {
+      globalScope = new Scope();
+      OperatorGraph = new OperatorGraph();
+    }
+    protected EngineAlgorithm(string name)
+      : base(name) {
+      globalScope = new Scope();
+      OperatorGraph = new OperatorGraph();
+    }
+    protected EngineAlgorithm(string name, ParameterCollection parameters)
+      : base(name, parameters) {
+      globalScope = new Scope();
+      OperatorGraph = new OperatorGraph();
+    }
+    protected EngineAlgorithm(string name, string description)
+      : base(name, description) {
+      globalScope = new Scope();
+      OperatorGraph = new OperatorGraph();
+    }
+    protected EngineAlgorithm(string name, string description, ParameterCollection parameters)
+      : base(name, description, parameters) {
+      globalScope = new Scope();
+      OperatorGraph = new OperatorGraph();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      EngineAlgorithm clone = (EngineAlgorithm)base.Clone(cloner);
+      clone.globalScope = (IScope)cloner.Clone(globalScope);
+      clone.Engine = (IEngine)cloner.Clone(engine);
+      clone.OperatorGraph = (OperatorGraph)cloner.Clone(operatorGraph);
+      return clone;
+    }
+
+    protected override void OnCanceledChanged() {
+      if (Canceled && (engine != null))
+        engine.Stop();
+    }
+    protected override void OnPrepared() {
+      globalScope.Clear();
+      if (engine != null) {
+        ExecutionContext context = null;
+        if (operatorGraph.InitialOperator != null) {
+          if (Problem != null) {
+            context = new ExecutionContext(context, Problem, globalScope);
+            foreach (IParameter param in Problem.Parameters)
+              param.ExecutionContext = context;
+          }
+          context = new ExecutionContext(context, this, globalScope);
+          foreach (IParameter param in this.Parameters)
+            param.ExecutionContext = context;
+          context = new ExecutionContext(context, operatorGraph.InitialOperator, globalScope);
+        }
+        engine.Prepare(context);
+      }
+      base.OnPrepared();
+    }
+    protected override void OnStarted() {
+      if (engine != null) engine.Start();
+      base.OnStarted();
+    }
+
+    protected virtual void OnOperatorGraphChanged() { }
+
+    public event EventHandler EngineChanged;
+    protected virtual void OnEngineChanged() {
+      if (EngineChanged != null)
+        EngineChanged(this, EventArgs.Empty);
+      OnChanged();
+    }
+
+    private void OperatorGraph_InitialOperatorChanged(object sender, EventArgs e) {
+      Prepare();
+    }
+    private void RegisterEngineEvents() {
+      Engine.Changed += new ChangedEventHandler(Engine_Changed);
+      Engine.ExceptionOccurred += new EventHandler<EventArgs<Exception>>(Engine_ExceptionOccurred);
+      Engine.ExecutionTimeChanged += new EventHandler(Engine_ExecutionTimeChanged);
+      Engine.Stopped += new EventHandler(Engine_Stopped);
+    }
+    private void DeregisterEngineEvents() {
+      Engine.Changed -= new ChangedEventHandler(Engine_Changed);
+      Engine.ExceptionOccurred -= new EventHandler<EventArgs<Exception>>(Engine_ExceptionOccurred);
+      Engine.ExecutionTimeChanged -= new EventHandler(Engine_ExecutionTimeChanged);
+      Engine.Stopped -= new EventHandler(Engine_Stopped);
+    }
+
+    private void Engine_ExceptionOccurred(object sender, EventArgs<Exception> e) {
+      OnExceptionOccurred(e.Value);
+    }
+    private void Engine_ExecutionTimeChanged(object sender, EventArgs e) {
+      OnExecutionTimeChanged();
+    }
+    private void Engine_Stopped(object sender, EventArgs e) {
+      OnStopped();
+    }
+    private void Engine_Changed(object sender, ChangedEventArgs e) {
+      OnChanged(e);
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj	(revision 2850)
+++ trunk/sources/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj	(revision 2851)
@@ -51,4 +51,7 @@
   <ItemGroup>
     <None Include="HeuristicLabOptimizationPlugin.cs.frame" />
+    <Compile Include="Algorithm.cs" />
+    <Compile Include="UserDefinedAlgorithm.cs" />
+    <Compile Include="EngineAlgorithm.cs" />
     <Compile Include="IAlgorithm.cs" />
     <Compile Include="HeuristicLabOptimizationPlugin.cs" />
Index: trunk/sources/HeuristicLab.Optimization/3.3/IAlgorithm.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/IAlgorithm.cs	(revision 2850)
+++ trunk/sources/HeuristicLab.Optimization/3.3/IAlgorithm.cs	(revision 2851)
@@ -38,4 +38,5 @@
     void Stop();
 
+    event EventHandler ProblemChanged;
     event EventHandler ExecutionTimeChanged;
     event EventHandler Prepared;
@@ -43,5 +44,4 @@
     event EventHandler Stopped;
     event EventHandler<EventArgs<Exception>> ExceptionOccurred;
-
   }
 }
Index: trunk/sources/HeuristicLab.Optimization/3.3/Problem.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/Problem.cs	(revision 2850)
+++ trunk/sources/HeuristicLab.Optimization/3.3/Problem.cs	(revision 2851)
@@ -22,10 +22,12 @@
 using System.Drawing;
 using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Optimization {
   /// <summary>
-  /// The base class for all problems.
+  /// A base class for problems.
   /// </summary>
-  [Item("Problem", "Base class for problems.")]
+  [Item("Problem", "A base class for problems.")]
+  [EmptyStorableClass]
   public abstract class Problem : ParameterizedNamedItem, IProblem {
     public override Image ItemImage {
Index: trunk/sources/HeuristicLab.Optimization/3.3/UserDefinedAlgorithm.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/UserDefinedAlgorithm.cs	(revision 2851)
+++ trunk/sources/HeuristicLab.Optimization/3.3/UserDefinedAlgorithm.cs	(revision 2851)
@@ -0,0 +1,59 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Collections;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Optimization {
+  /// <summary>
+  /// An algorithm which can be defined by the user.
+  /// </summary>
+  [Item("UserDefinedAlgorithm", "An algorithm which can be defined by the user.")]
+  [Creatable("Algorithms")]
+  [EmptyStorableClass]
+  public sealed class UserDefinedAlgorithm : EngineAlgorithm, IParameterizedItem {
+    public new ParameterCollection Parameters {
+      get { return base.Parameters; }
+    }
+    IObservableKeyedCollection<string, IParameter> IParameterizedItem.Parameters {
+      get { return Parameters; }
+    }
+
+    public new OperatorGraph OperatorGraph {
+      get { return base.OperatorGraph; }
+      set { base.OperatorGraph = value; }
+    }
+
+    public new IScope GlobalScope {
+      get { return base.GlobalScope; }
+    }
+
+    public UserDefinedAlgorithm() : base() { }
+
+    public event EventHandler OperatorGraphChanged;
+    protected override void OnOperatorGraphChanged() {
+      if (OperatorGraphChanged != null)
+        OperatorGraphChanged(this, EventArgs.Empty);
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.SGA/3.3/HeuristicLab.SGA-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.SGA/3.3/HeuristicLab.SGA-3.3.csproj	(revision 2850)
+++ trunk/sources/HeuristicLab.SGA/3.3/HeuristicLab.SGA-3.3.csproj	(revision 2851)
@@ -83,4 +83,5 @@
   <ItemGroup>
     <None Include="HeuristicLabSGAPlugin.cs.frame" />
+    <Compile Include="SGA.cs" />
     <Compile Include="SGAOperator.cs" />
     <Compile Include="HeuristicLabSGAPlugin.cs" />
@@ -108,4 +109,8 @@
       <Name>HeuristicLab.Operators-3.3</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Optimization\3.3\HeuristicLab.Optimization-3.3.csproj">
+      <Project>{14AB8D24-25BC-400C-A846-4627AA945192}</Project>
+      <Name>HeuristicLab.Optimization-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Parameters\3.3\HeuristicLab.Parameters-3.3.csproj">
       <Project>{56F9106A-079F-4C61-92F6-86A84C2D84B7}</Project>
@@ -119,4 +124,8 @@
       <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
       <Name>HeuristicLab.PluginInfrastructure</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Random\3.3\HeuristicLab.Random-3.3.csproj">
+      <Project>{F4539FB6-4708-40C9-BE64-0A1390AEA197}</Project>
+      <Name>HeuristicLab.Random-3.3</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Selection\3.3\HeuristicLab.Selection-3.3.csproj">
Index: trunk/sources/HeuristicLab.SGA/3.3/HeuristicLabSGAPlugin.cs.frame
===================================================================
--- trunk/sources/HeuristicLab.SGA/3.3/HeuristicLabSGAPlugin.cs.frame	(revision 2850)
+++ trunk/sources/HeuristicLab.SGA/3.3/HeuristicLabSGAPlugin.cs.frame	(revision 2851)
@@ -33,6 +33,8 @@
   [PluginDependency("HeuristicLab.Evolutionary", "3.3")]
   [PluginDependency("HeuristicLab.Operators", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
   [PluginDependency("HeuristicLab.Parameters", "3.3")]
   [PluginDependency("HeuristicLab.Persistence", "3.3")]
+  [PluginDependency("HeuristicLab.Random", "3.3")]
   [PluginDependency("HeuristicLab.Selection", "3.3")]
   public class HeuristicLabSGAPlugin : PluginBase {
